/*
    ShapeSpatialPakTemplateCmd.cc

    Will 18, 2001: will@opaline.demon.co.uk
*/

#include "Application.h"
#include "OpResources.h"
#include "ShapeSpatialPakTemplateCmd.h"
#include "AppWindow.h"
#include <MessageDialogManager.h>
#include <Xm/Label.h>
#include <Xm/Form.h>
#include <Xm/RowColumn.h>
#include <Xm/Protocols.h>
#include <Xm/TextF.h>
#include <Xm/PushB.h>
#include <Xm/Separator.h>
#include <GraphIntCmd.h>
#include <GraphFltCmd.h>
#include "MixwaveUtils.h"
#include <math.h>
#include "DataConformCmd.h"
#include <InfoDialogManager.h>


ShapeSpatialPakTemplateCmd::ShapeSpatialPakTemplateCmd ( char *name, int active, unsigned int numDigits, unsigned int fpDigits ) : NoUndoCmd ( name, active )
{
	_numDigits = numDigits;	// use resources, cut from constr?
	_fpDigits = fpDigits;
	_name = name;
	_shapeTemplateRealised = False;
	_dataOffset = 0;
	_startRange = 0;
	_endRange = 0;
	_startSel = 0;
	_endSel = 0;
	_xCurrent = 0;
	_min = 0;
	_max = 0;
	_idata = NULL;
	_fdata = NULL;
	_dataChanged = 0;
	_viewID = 0;	// owner of current selection
}


ShapeSpatialPakTemplateCmd::~ShapeSpatialPakTemplateCmd()
{
	if ( _shapeTemplateRealised == True )
	{
		XtDestroyWidget ( _popup );
		_shapeTemplateRealised = False;
	}
	
	delete _utils;
}


void ShapeSpatialPakTemplateCmd::doCommand()
{
	if ( _shapeTemplateRealised == True )
		return;
	else
		_shapeTemplateRealised = True;

	_utils = new MixwaveUtils;
	
	int n;
	Arg args[5];
	Atom WM_DELETE_WINDOW;

	_popup = XtCreatePopupShell ( _name, transientShellWidgetClass,
						application->baseWidget(), NULL, 0 );

	_form = XtCreateManagedWidget ( "Form", xmFormWidgetClass, _popup,
						NULL, 0 );

	_label = XtVaCreateManagedWidget ( "none", xmLabelWidgetClass, _form, 
						XmNtopAttachment, XmATTACH_FORM,
						XmNleftAttachment, XmATTACH_FORM,
						NULL );

	_sep = XtVaCreateManagedWidget ( "sep", xmSeparatorWidgetClass, _form,
						XmNtopAttachment, XmATTACH_WIDGET,
						XmNtopWidget, _label,
						XmNleftAttachment, XmATTACH_FORM,
						XmNrightAttachment, XmATTACH_FORM,
						XmNseparatorType, XmSHADOW_ETCHED_IN,
						NULL );
										
	_rc1 = XtVaCreateManagedWidget ( "RowColumn1", xmRowColumnWidgetClass, _form,
						XmNorientation, XmHORIZONTAL,
						XmNnumColumns, 1,
						XmNpacking, XmPACK_COLUMN,
						XmNleftAttachment, XmATTACH_FORM,
						XmNrightAttachment, XmATTACH_FORM,
						XmNtopAttachment, XmATTACH_WIDGET,
						XmNtopWidget, _sep,
						NULL );

	_rc2 = XtVaCreateManagedWidget ( "RowColumn2", xmRowColumnWidgetClass, _form,
						XmNorientation, XmHORIZONTAL,
						XmNnumColumns, 1,
						XmNpacking, XmPACK_COLUMN,
						XmNleftAttachment, XmATTACH_FORM,
						XmNrightAttachment, XmATTACH_FORM,
						XmNtopAttachment, XmATTACH_WIDGET,
						XmNtopWidget, _rc1,
						NULL );

	_rc3 = XtVaCreateManagedWidget ( "RowColumn3", xmRowColumnWidgetClass, _form,
						XmNorientation, XmHORIZONTAL,
						XmNnumColumns, 1,
						XmNpacking, XmPACK_COLUMN,
						XmNleftAttachment, XmATTACH_FORM,
						XmNrightAttachment, XmATTACH_FORM,
						XmNtopAttachment, XmATTACH_WIDGET,
						XmNtopWidget, _rc2,
						NULL );

	_rc4 = XtVaCreateManagedWidget ( "RowColumn4", xmRowColumnWidgetClass, _form,
						XmNorientation, XmHORIZONTAL,
						XmNnumColumns, 1,
						XmNpacking, XmPACK_COLUMN,
						XmNleftAttachment, XmATTACH_FORM,
						XmNrightAttachment, XmATTACH_FORM,
						XmNtopAttachment, XmATTACH_WIDGET,
						XmNtopWidget, _rc3,
						NULL );

	_rc5 = XtVaCreateManagedWidget ( "RowColumn4", xmRowColumnWidgetClass, _form,
						XmNorientation, XmHORIZONTAL,
						XmNnumColumns, 1,
						XmNpacking, XmPACK_COLUMN,
						XmNleftAttachment, XmATTACH_FORM,
						XmNrightAttachment, XmATTACH_FORM,
						XmNtopAttachment, XmATTACH_WIDGET,
						XmNtopWidget, _rc4,
						NULL );

	_rc6 = XtVaCreateManagedWidget ( "RowColumn6", xmRowColumnWidgetClass, _form,
						XmNorientation, XmHORIZONTAL,
						XmNnumColumns, 1,
						XmNpacking, XmPACK_COLUMN,
						XmNleftAttachment, XmATTACH_FORM,
						XmNrightAttachment, XmATTACH_FORM,
						XmNtopAttachment, XmATTACH_WIDGET,
						XmNtopWidget, _rc5,
						NULL );

	_rc7 = XtVaCreateManagedWidget ( "RowColumn7", xmRowColumnWidgetClass, _form,
						XmNorientation, XmHORIZONTAL,
						XmNnumColumns, 1,
						XmNpacking, XmPACK_COLUMN,
						XmNleftAttachment, XmATTACH_FORM,
						XmNrightAttachment, XmATTACH_FORM,
						XmNtopAttachment, XmATTACH_WIDGET,
						XmNtopWidget, _rc6,
						NULL );

	n = 0;

	XtSetArg ( args[n], XmNcolumns, _numDigits ); n++;
	XtSetArg ( args[n], XmNeditable, TRUE ); n++;
	XtSetArg ( args[n], XmNcursorPositionVisible, TRUE ); n++;
	XtSetArg ( args[n], XmNmaxLength, _numDigits+_fpDigits ); n++;

	_funct1 = XtCreateManagedWidget ( "Line", xmPushButtonWidgetClass,_rc1, NULL, 0 );
	_label1a = XtCreateManagedWidget ( "Initial", xmLabelWidgetClass, _rc1, NULL, 0 );
	_field1a = XtCreateManagedWidget ( "field1a", xmTextFieldWidgetClass, _rc1, args, n );
	_label1b = XtCreateManagedWidget ( "Final", xmLabelWidgetClass, _rc1, NULL, 0 );
	_field1b = XtCreateManagedWidget ( "field1b", xmTextFieldWidgetClass, _rc1, args, n );

	XtAddCallback ( _funct1, XmNactivateCallback, &ShapeSpatialPakTemplateCmd::funct1Callback, ( XtPointer ) this );
	XtAddCallback ( _field1a, XmNactivateCallback, &ShapeSpatialPakTemplateCmd::field1aEntryCallback, ( XtPointer ) this );
	XtAddCallback ( _field1b, XmNactivateCallback, &ShapeSpatialPakTemplateCmd::field1bEntryCallback, ( XtPointer ) this );

	_funct2 = XtCreateManagedWidget ( "Sine", xmPushButtonWidgetClass,_rc2, NULL, 0 );
	_label2a = XtCreateManagedWidget ( "Repeats", xmLabelWidgetClass, _rc2, NULL, 0 );
	_field2a = XtCreateManagedWidget ( "field2a", xmTextFieldWidgetClass, _rc2, args, n );
	_label2b = XtCreateManagedWidget ( "Offset", xmLabelWidgetClass, _rc2, NULL, 0 );
	_field2b = XtCreateManagedWidget ( "field2b", xmTextFieldWidgetClass, _rc2, args, n );

	XtAddCallback ( _funct2, XmNactivateCallback, &ShapeSpatialPakTemplateCmd::funct2Callback, ( XtPointer ) this );
	XtAddCallback ( _field2a, XmNactivateCallback, &ShapeSpatialPakTemplateCmd::field2aEntryCallback, ( XtPointer ) this );
	XtAddCallback ( _field2b, XmNactivateCallback, &ShapeSpatialPakTemplateCmd::field2bEntryCallback, ( XtPointer ) this );

	_funct3 = XtCreateManagedWidget ( "Tan", xmPushButtonWidgetClass,_rc3, NULL, 0 );
	_label3a = XtCreateManagedWidget ( "Initial", xmLabelWidgetClass, _rc3, NULL, 0 );
	_field3a = XtCreateManagedWidget ( "field3a", xmTextFieldWidgetClass, _rc3, args, n );
	_label3b = XtCreateManagedWidget ( "Final", xmLabelWidgetClass, _rc3, NULL, 0 );
	_field3b = XtCreateManagedWidget ( "field3b", xmTextFieldWidgetClass, _rc3, args, n );

	XtAddCallback ( _funct3, XmNactivateCallback, &ShapeSpatialPakTemplateCmd::funct3Callback, ( XtPointer ) this );
	XtAddCallback ( _field3a, XmNactivateCallback, &ShapeSpatialPakTemplateCmd::field3aEntryCallback, ( XtPointer ) this );
	XtAddCallback ( _field3b, XmNactivateCallback, &ShapeSpatialPakTemplateCmd::field3bEntryCallback, ( XtPointer ) this );

	_funct4 = XtCreateManagedWidget ( "Exp", xmPushButtonWidgetClass,_rc4, NULL, 0 );
	_label4a = XtCreateManagedWidget ( "Initial", xmLabelWidgetClass, _rc4, NULL, 0 );
	_field4a = XtCreateManagedWidget ( "field4a", xmTextFieldWidgetClass, _rc4, args, n );
	_label4b = XtCreateManagedWidget ( "Final", xmLabelWidgetClass, _rc4, NULL, 0 );
	_field4b = XtCreateManagedWidget ( "field4b", xmTextFieldWidgetClass, _rc4, args, n );

	XtAddCallback ( _funct4, XmNactivateCallback, &ShapeSpatialPakTemplateCmd::funct4Callback, ( XtPointer ) this );
	XtAddCallback ( _field4a, XmNactivateCallback, &ShapeSpatialPakTemplateCmd::field4aEntryCallback, ( XtPointer ) this );
	XtAddCallback ( _field4b, XmNactivateCallback, &ShapeSpatialPakTemplateCmd::field4bEntryCallback, ( XtPointer ) this );

	_funct5 = XtCreateManagedWidget ( "Log", xmPushButtonWidgetClass,_rc5, NULL, 0 );
	_label5a = XtCreateManagedWidget ( "Initial", xmLabelWidgetClass, _rc5, NULL, 0 );
	_field5a = XtCreateManagedWidget ( "field5a", xmTextFieldWidgetClass, _rc5, args, n );
	_label5b = XtCreateManagedWidget ( "Final", xmLabelWidgetClass, _rc5, NULL, 0 );
	_field5b = XtCreateManagedWidget ( "field5b", xmTextFieldWidgetClass, _rc5, args, n );

	XtAddCallback ( _funct5, XmNactivateCallback, &ShapeSpatialPakTemplateCmd::funct5Callback, ( XtPointer ) this );
	XtAddCallback ( _field5a, XmNactivateCallback, &ShapeSpatialPakTemplateCmd::field5aEntryCallback, ( XtPointer ) this );
	XtAddCallback ( _field5b, XmNactivateCallback, &ShapeSpatialPakTemplateCmd::field5bEntryCallback, ( XtPointer ) this );

	_funct6 = XtCreateManagedWidget ( "Resize", xmPushButtonWidgetClass,_rc6, NULL, 0 );
	_label6a = XtCreateManagedWidget ( "Shift", xmLabelWidgetClass, _rc6, NULL, 0 );
	_field6a = XtCreateManagedWidget ( "field6a", xmTextFieldWidgetClass, _rc6, args, n );
	_label6b = XtCreateManagedWidget ( "Scale", xmLabelWidgetClass, _rc6, NULL, 0 );
	_field6b = XtCreateManagedWidget ( "field6b", xmTextFieldWidgetClass, _rc6, args, n );

	XtAddCallback ( _funct6, XmNactivateCallback, &ShapeSpatialPakTemplateCmd::funct6Callback, ( XtPointer ) this );
	XtAddCallback ( _field6a, XmNactivateCallback, &ShapeSpatialPakTemplateCmd::field6aEntryCallback, ( XtPointer ) this );
	XtAddCallback ( _field6b, XmNactivateCallback, &ShapeSpatialPakTemplateCmd::field6bEntryCallback, ( XtPointer ) this );

	_funct7 = XtCreateManagedWidget ( "Smooth", xmPushButtonWidgetClass,_rc7, NULL, 0 );
	_label7a = XtCreateManagedWidget ( "Points", xmLabelWidgetClass, _rc7, NULL, 0 );
	_field7a = XtCreateManagedWidget ( "field7a", xmTextFieldWidgetClass, _rc7, args, n );
	_label7b = XtCreateManagedWidget ( "weighting", xmLabelWidgetClass, _rc7, NULL, 0 );
	_field7b = XtCreateManagedWidget ( "field7b", xmTextFieldWidgetClass, _rc7, args, n );

	XtAddCallback ( _funct7, XmNactivateCallback, &ShapeSpatialPakTemplateCmd::funct7Callback, ( XtPointer ) this );
	XtAddCallback ( _field7a, XmNactivateCallback, &ShapeSpatialPakTemplateCmd::field7aEntryCallback, ( XtPointer ) this );
	XtAddCallback ( _field7b, XmNactivateCallback, &ShapeSpatialPakTemplateCmd::field7bEntryCallback, ( XtPointer ) this );

	// cater for WM 'X' pressed
	WM_DELETE_WINDOW = XmInternAtom ( XtDisplay ( _popup ), "WM_DELETE_WINDOW", False );
	XmAddWMProtocols ( _popup, &WM_DELETE_WINDOW, 1 );
	XmAddWMProtocolCallback ( _popup, WM_DELETE_WINDOW, clientMessageProc, ( XtPointer ) this );

	changeField1a ( 0 );
	changeField1b ( 0 );
	changeField2a ( 1 );
	changeField2b ( 0 );
	changeField3a ( -1.571 );
	changeField3b ( 1.571 );
	changeField4a ( 0 );
	changeField4b ( 0 );
	changeField5a ( 1 );
	changeField5b ( 1 );
	changeField6a ( 0 );
	changeField6b ( 1 );
	changeField7a ( 3 );	// min data points for curve fit, 0 for simple interpolation
	changeField7b ( 2 );
	
	XtPopup ( _popup, ( XtGrabKind ) XtGrabNone );
	XtManageChild ( _popup );
}


void ShapeSpatialPakTemplateCmd::clientMessageProc ( Widget, XtPointer clientData, XtPointer )
{
	// empty - WM close disabled, external quit call from owner closes this
}


void ShapeSpatialPakTemplateCmd::setTitle ( char *title )
{
	char name [ strlen ( title ) + 8 ];

	strncpy ( name, _utils->fileFromPath ( title ), sizeof ( name ) );
	name [ sizeof ( name ) - 1 ] = 0;

	XmString xmstr = XmStringCreateSimple ( ( char * ) name );
	XtVaSetValues ( _label, XmNlabelString, xmstr, NULL );
	XmStringFree ( xmstr );
}


void ShapeSpatialPakTemplateCmd::funct1Callback ( Widget, XtPointer clientData, XtPointer )
{
	ShapeSpatialPakTemplateCmd *obj = ( ShapeSpatialPakTemplateCmd * ) clientData;
	char text1[obj->_numDigits+obj->_fpDigits];
	char text2[obj->_numDigits+obj->_fpDigits];
	float value1, value2;

	snprintf ( text1, sizeof ( text1 ), "%s", XmTextFieldGetString ( obj->_field1a ) );
	text1 [ sizeof ( text1 ) - 1 ] = 0;

	if ( strlen ( text1 ) > 0 )
		sscanf ( text1, "%f", &value1 );
	else
	{
		value1 = 0;
		obj->changeField1a ( value1 );
	}
	
	snprintf ( text2, sizeof ( text2 ), "%s", XmTextFieldGetString ( obj->_field1b ) );
	text2 [ sizeof ( text2 ) - 1 ] = 0;

	if ( strlen ( text2 ) > 0 )
		sscanf ( text2, "%f", &value2 );
	else
	{
		value2 = 0;
		obj->changeField1b ( value2 );
	}
	
	obj->funct1 ( value1, value2 );
}


void ShapeSpatialPakTemplateCmd::funct1 ( float start, float end )
{
	if ( _dataType == 0 )
	{
		if ( _gic == NULL )
			return;
	}
	else
	{
		if ( _gfc == NULL )
			return;
	}

	long count;
	float value = start;

	if ( readData() == 1 )
		return;

	// function body
	float increment = ( end - start ) / ( _endData - _startData );

	for ( count = _startData; count <= _endData; count ++ )
	{
		if ( _dataType == 0 )	// int
			_idata [ count - _dataOffset ] = ( int ) ( value + 0.5 );
		else
			_fdata [ count - _dataOffset ] = value;

		value += increment;
//printf("count %ld offset %ld datum %ld value %f\n", count, _dataOffset,
//count-_dataOffset,_fdata[count-_dataOffset]);
	}

	writeData();
}


void ShapeSpatialPakTemplateCmd::field1aEntryCallback ( Widget, XtPointer clientData, XtPointer )
{
	ShapeSpatialPakTemplateCmd* obj = ( ShapeSpatialPakTemplateCmd * ) clientData;
	char text[obj->_numDigits+obj->_fpDigits];

	snprintf ( text, sizeof ( text ), "%s", XmTextFieldGetString ( obj->_field1a ) );
	text [ sizeof ( text ) - 1 ] = 0;
	
	if ( strlen ( text ) == 0 )
	{
		strncpy ( text, "0", sizeof ( text ) );
		text [ sizeof ( text ) ] = 0;
	}

	obj->field1aEntry ( text );
}


void ShapeSpatialPakTemplateCmd::field1bEntryCallback ( Widget, XtPointer clientData, XtPointer )
{
	ShapeSpatialPakTemplateCmd* obj = ( ShapeSpatialPakTemplateCmd * ) clientData;
	char text[obj->_numDigits+obj->_fpDigits];

	snprintf ( text, sizeof ( text ), "%s", XmTextFieldGetString ( obj->_field1b ) );
	text [ sizeof ( text ) - 1 ] = 0;

	if ( strlen ( text ) == 0 )
	{
		strncpy ( text, "0", sizeof ( text ) );
		text [ sizeof ( text ) ] = 0;
	}

	obj->field1bEntry ( text );
}


void ShapeSpatialPakTemplateCmd::field1aEntry ( char *text )
{
	float value;
	
	if ( !checkTextEntry ( text ) )
	{
		sscanf ( text, "%f\n", &value );
		changeField1a ( value );
	}
	else
		changeField1a ( 0 );
}


void ShapeSpatialPakTemplateCmd::field1bEntry ( char *text )
{
	float value;
	
	if ( !checkTextEntry ( text ) )
	{
		sscanf ( text, "%f\n", &value );
		changeField1b ( value );
	}
	else
		changeField1b ( 1 );
}


void ShapeSpatialPakTemplateCmd::changeField1a ( float value )
{
	char text[ _numDigits + _fpDigits + 1 ];
	char formatString[ _numDigits + _fpDigits + 1 ];

	snprintf ( formatString, sizeof ( formatString ),"%s%d%s", "%.", _fpDigits, "f" );
	formatString [ sizeof ( formatString ) - 1 ] = 0;
	snprintf ( text, sizeof ( text ), formatString, value );	// use format string
	text [ sizeof ( text ) - 1 ] = 0;
	sprintf ( text, "%f", value );
	XmTextFieldSetString ( _field1a, text );
}


void ShapeSpatialPakTemplateCmd::changeField1b ( float value )
{
	char text[ _numDigits + _fpDigits + 1];
	char formatString[ _numDigits + _fpDigits + 1 ];

	snprintf ( formatString, sizeof ( formatString ),"%s%d%s", "%.", _fpDigits, "f" );
	formatString [ sizeof ( formatString ) - 1 ] = 0;
	snprintf ( text, sizeof ( text ), formatString, value );	// use format string
	text [ sizeof ( text ) - 1 ] = 0;
	sprintf ( text, "%f", value );

	XmTextFieldSetString ( _field1b, text );
}


void ShapeSpatialPakTemplateCmd::funct2Callback ( Widget, XtPointer clientData, XtPointer )
{
	ShapeSpatialPakTemplateCmd *obj = ( ShapeSpatialPakTemplateCmd * ) clientData;

	char text1[obj->_numDigits+obj->_fpDigits];
	char text2[obj->_numDigits+obj->_fpDigits];
	float value1, value2;

	snprintf ( text1, sizeof ( text1 ), "%s", XmTextFieldGetString ( obj->_field2a ) );
	text1 [ sizeof ( text1 ) - 1 ] = 0;

	if ( strlen ( text1 ) > 0 )
		sscanf ( text1, "%f", &value1 );
	else
	{
		value1 = 1;
		obj->changeField2a ( value1 );
	}
	
	snprintf ( text2, sizeof ( text2 ), "%s", XmTextFieldGetString ( obj->_field2b ) );
	text2 [ sizeof ( text2 ) - 1 ] = 0;

	if ( strlen ( text2 ) > 0 )
		sscanf ( text2, "%f", &value2 );
	else
	{
		value2 = 0;
		obj->changeField2b ( value2 );
	}
	
	obj->funct2 ( value1, value2 );
}


void ShapeSpatialPakTemplateCmd::funct2 ( float repeats, float offset )
{
	if ( _dataType == 0 )
	{
		if ( _gic == NULL )
			return;
	}
	else
	{
		if ( _gfc == NULL )
			return;
	}

	
	if ( repeats == 0 )
	{
		changeField2a ( 1 );
		return;
	}

	long count;
	float value, scale, increment;

	if ( readData() == 1 )
		return;

	// function body
	increment = ( repeats / ( _endData - _startData ) ) * 2 * 3.141592654;
	value = offset;
	scale = _max;
	
	for ( count = _startData; count <= _endData; count ++ )
	{
		if ( _dataType == 0 )	// int
		{
			_idata [ count - _dataOffset ] = ( int ) ( sin ( value ) * scale );
			value += increment;
		}
		else
		{
			_fdata [ count - _dataOffset ] = sin ( value ) * scale;
			value += increment;
		}
	}

	writeData();
}


void ShapeSpatialPakTemplateCmd::field2aEntryCallback ( Widget, XtPointer clientData, XtPointer )
{
	ShapeSpatialPakTemplateCmd* obj = ( ShapeSpatialPakTemplateCmd * ) clientData;
	char text[obj->_numDigits+obj->_fpDigits];

	snprintf ( text, sizeof ( text ), "%s", XmTextFieldGetString ( obj->_field2a ) );
	text [ sizeof ( text ) - 1 ] = 0;
	
	if ( strlen ( text ) == 0 )
	{
		strncpy ( text, "1", sizeof ( text ) );
		text [ sizeof ( text ) ] = 0;
	}

	obj->field2aEntry ( text );
}


void ShapeSpatialPakTemplateCmd::field2bEntryCallback ( Widget, XtPointer clientData, XtPointer )
{
	ShapeSpatialPakTemplateCmd* obj = ( ShapeSpatialPakTemplateCmd * ) clientData;
	char text[obj->_numDigits+obj->_fpDigits];

	snprintf ( text, sizeof ( text ), "%s", XmTextFieldGetString ( obj->_field2b ) );
	text [ sizeof ( text ) - 1 ] = 0;

	if ( strlen ( text ) == 0 )
	{
		strncpy ( text, "0", sizeof ( text ) );
		text [ sizeof ( text ) ] = 0;
	}

	obj->field2bEntry ( text );
}


void ShapeSpatialPakTemplateCmd::field2aEntry ( char *text )
{
	float value;
	
	if ( !checkTextEntry ( text ) )
	{
		sscanf ( text, "%f\n", &value );
		changeField2a ( value );
	}
	else
		changeField2a ( 1 );
}


void ShapeSpatialPakTemplateCmd::field2bEntry ( char *text )
{
	float value;
	
	if ( !checkTextEntry ( text ) )
	{
		sscanf ( text, "%f\n", &value );
		changeField2b ( value );
	}
	else
		changeField2b ( 0 );
}


void ShapeSpatialPakTemplateCmd::changeField2a ( float value )
{
	char text[ _numDigits + _fpDigits + 1 ];
	char formatString[ _numDigits + _fpDigits + 1 ];

	snprintf ( formatString, sizeof ( formatString ),"%s%d%s", "%.", _fpDigits, "f" );
	formatString [ sizeof ( formatString ) - 1 ] = 0;
	snprintf ( text, sizeof ( text ), formatString, value );	// use format string
	text [ sizeof ( text ) - 1 ] = 0;
	sprintf ( text, "%f", value );
	XmTextFieldSetString ( _field2a, text );
}


void ShapeSpatialPakTemplateCmd::changeField2b ( float value )
{
	char text[ _numDigits + _fpDigits + 1];
	char formatString[ _numDigits + _fpDigits + 1 ];

	snprintf ( formatString, sizeof ( formatString ),"%s%d%s", "%.", _fpDigits, "f" );
	formatString [ sizeof ( formatString ) - 1 ] = 0;
	snprintf ( text, sizeof ( text ), formatString, value );	// use format string
	text [ sizeof ( text ) - 1 ] = 0;
	sprintf ( text, "%f", value );

	XmTextFieldSetString ( _field2b, text );
}


void ShapeSpatialPakTemplateCmd::funct3Callback ( Widget, XtPointer clientData, XtPointer )
{
	ShapeSpatialPakTemplateCmd *obj = ( ShapeSpatialPakTemplateCmd * ) clientData;

	char text1[obj->_numDigits+obj->_fpDigits];
	char text2[obj->_numDigits+obj->_fpDigits];
	float value1, value2;

	snprintf ( text1, sizeof ( text1 ), "%s", XmTextFieldGetString ( obj->_field3a ) );
	text1 [ sizeof ( text1 ) - 1 ] = 0;

	if ( strlen ( text1 ) > 0 )
		sscanf ( text1, "%f", &value1 );
	else
	{
		value1 = 0;
		obj->changeField3a ( value1 );
	}
	
	snprintf ( text2, sizeof ( text2 ), "%s", XmTextFieldGetString ( obj->_field3b ) );
	text2 [ sizeof ( text2 ) - 1 ] = 0;

	if ( strlen ( text2 ) > 0 )
		sscanf ( text2, "%f", &value2 );
	else
	{
		value2 = 0;
		obj->changeField3b ( value2 );
	}
	
	obj->funct3 ( value1, value2 );
}


void ShapeSpatialPakTemplateCmd::funct3 ( float start, float end )
{
	if ( _dataType == 0 )
	{
		if ( _gic == NULL )
			return;
	}
	else
	{
		if ( _gfc == NULL )
			return;
	}

	long count;
	float value, scale, increment;

	if ( readData() == 1 )
		return;

	// function body
	increment = ( end - start ) / ( _endData - _startData );
	scale = _max;
	value = start;

	for ( count = _startData; count <= _endData; count ++ )
	{

		if ( _dataType == 0 )	// int
		{
			_idata [ count - _dataOffset ] = ( int ) ( tan ( value ) * scale ) ;
			value += increment;
		}
		else
		{
			_fdata [ count - _dataOffset ] = ( float ) tan ( value );
			value += increment;
		}
	}

	writeData();
}


void ShapeSpatialPakTemplateCmd::field3aEntryCallback ( Widget, XtPointer clientData, XtPointer )
{
	ShapeSpatialPakTemplateCmd* obj = ( ShapeSpatialPakTemplateCmd * ) clientData;
	char text[obj->_numDigits+obj->_fpDigits];

	snprintf ( text, sizeof ( text ), "%s", XmTextFieldGetString ( obj->_field3a ) );
	text [ sizeof ( text ) - 1 ] = 0;
	
	if ( strlen ( text ) == 0 )
	{
		strncpy ( text, "0", sizeof ( text ) );
		text [ sizeof ( text ) ] = 0;
	}

	obj->field3aEntry ( text );
}


void ShapeSpatialPakTemplateCmd::field3bEntryCallback ( Widget, XtPointer clientData, XtPointer )
{
	ShapeSpatialPakTemplateCmd* obj = ( ShapeSpatialPakTemplateCmd * ) clientData;
	char text[obj->_numDigits+obj->_fpDigits];

	snprintf ( text, sizeof ( text ), "%s", XmTextFieldGetString ( obj->_field3b ) );
	text [ sizeof ( text ) - 1 ] = 0;

	if ( strlen ( text ) == 0 )
	{
		strncpy ( text, "0", sizeof ( text ) );
		text [ sizeof ( text ) ] = 0;
	}

	obj->field3bEntry ( text );
}


void ShapeSpatialPakTemplateCmd::field3aEntry ( char *text )
{
	float value;
	
	if ( !checkTextEntry ( text ) )
	{
		sscanf ( text, "%f\n", &value );
		changeField3a ( value );
	}
	else
		changeField3a ( 0 );
}


void ShapeSpatialPakTemplateCmd::field3bEntry ( char *text )
{
	float value;
	
	if ( !checkTextEntry ( text ) )
	{
		sscanf ( text, "%f\n", &value );
		changeField3b ( value );
	}
	else
		changeField3b ( 0 );
}


void ShapeSpatialPakTemplateCmd::changeField3a ( float value )
{
	char text[ _numDigits + _fpDigits + 1 ];
	char formatString[ _numDigits + _fpDigits + 1 ];

	snprintf ( formatString, sizeof ( formatString ),"%s%d%s", "%.", _fpDigits, "f" );
	formatString [ sizeof ( formatString ) - 1 ] = 0;
	snprintf ( text, sizeof ( text ), formatString, value );	// use format string
	text [ sizeof ( text ) - 1 ] = 0;
	sprintf ( text, "%f", value );
	XmTextFieldSetString ( _field3a, text );
}


void ShapeSpatialPakTemplateCmd::changeField3b ( float value )
{
	char text[ _numDigits + _fpDigits + 1];
	char formatString[ _numDigits + _fpDigits + 1 ];

	snprintf ( formatString, sizeof ( formatString ),"%s%d%s", "%.", _fpDigits, "f" );
	formatString [ sizeof ( formatString ) - 1 ] = 0;
	snprintf ( text, sizeof ( text ), formatString, value );	// use format string
	text [ sizeof ( text ) - 1 ] = 0;
	sprintf ( text, "%f", value );

	XmTextFieldSetString ( _field3b, text );
}


void ShapeSpatialPakTemplateCmd::funct4Callback ( Widget, XtPointer clientData, XtPointer )
{
	ShapeSpatialPakTemplateCmd *obj = ( ShapeSpatialPakTemplateCmd * ) clientData;

	char text1[obj->_numDigits+obj->_fpDigits];
	char text2[obj->_numDigits+obj->_fpDigits];
	float value1, value2;

	snprintf ( text1, sizeof ( text1 ), "%s", XmTextFieldGetString ( obj->_field4a ) );
	text1 [ sizeof ( text1 ) - 1 ] = 0;

	if ( strlen ( text1 ) > 0 )
		sscanf ( text1, "%f", &value1 );
	else
	{
		value1 = 0;
		obj->changeField4a ( value1 );
	}
	
	snprintf ( text2, sizeof ( text2 ), "%s", XmTextFieldGetString ( obj->_field4b ) );
	text2 [ sizeof ( text2 ) - 1 ] = 0;

	if ( strlen ( text2 ) > 0 )
		sscanf ( text2, "%f", &value2 );
	else
	{
		value2 = 0;
		obj->changeField4b ( value2 );
	}
	
	obj->funct4 ( value1, value2 );
}


void ShapeSpatialPakTemplateCmd::funct4 ( float start, float end )
{
	if ( _dataType == 0 )
	{
		if ( _gic == NULL )
			return;
	}
	else
	{
		if ( _gfc == NULL )
			return;
	}

	long count;
	float value, scale, increment;

	if ( readData() == 1 )
		return;

	// function body
	increment = ( end - start ) / ( _endData - _startData );
	scale = _max;
	value = start;

	for ( count = _startData; count <= _endData; count ++ )
	{
		if ( _dataType == 0 )	// int
		{
			_idata [ count - _dataOffset ] = ( int ) ( exp ( value ) * scale ) ;
			value += increment;
		}
		else
		{
			_fdata [ count - _dataOffset ] = ( float ) exp ( value );
			value += increment;
		}
	}

	writeData();
}


void ShapeSpatialPakTemplateCmd::field4aEntryCallback ( Widget, XtPointer clientData, XtPointer )
{
	ShapeSpatialPakTemplateCmd* obj = ( ShapeSpatialPakTemplateCmd * ) clientData;
	char text[obj->_numDigits+obj->_fpDigits];

	snprintf ( text, sizeof ( text ), "%s", XmTextFieldGetString ( obj->_field4a ) );
	text [ sizeof ( text ) - 1 ] = 0;
	
	if ( strlen ( text ) == 0 )
	{
		strncpy ( text, "0", sizeof ( text ) );
		text [ sizeof ( text ) ] = 0;
	}

	obj->field4aEntry ( text );
}


void ShapeSpatialPakTemplateCmd::field4bEntryCallback ( Widget, XtPointer clientData, XtPointer )
{
	ShapeSpatialPakTemplateCmd* obj = ( ShapeSpatialPakTemplateCmd * ) clientData;
	char text[obj->_numDigits+obj->_fpDigits];

	snprintf ( text, sizeof ( text ), "%s", XmTextFieldGetString ( obj->_field4b ) );
	text [ sizeof ( text ) - 1 ] = 0;

	if ( strlen ( text ) == 0 )
	{
		strncpy ( text, "0", sizeof ( text ) );
		text [ sizeof ( text ) ] = 0;
	}

	obj->field4bEntry ( text );
}


void ShapeSpatialPakTemplateCmd::field4aEntry ( char *text )
{
	float value;
	
	if ( !checkTextEntry ( text ) )
	{
		sscanf ( text, "%f\n", &value );
		changeField4a ( value );
	}
	else
		changeField4a ( 0 );
}


void ShapeSpatialPakTemplateCmd::field4bEntry ( char *text )
{
	float value;
	
	if ( !checkTextEntry ( text ) )
	{
		sscanf ( text, "%f\n", &value );
		changeField4b ( value );
	}
	else
		changeField4b ( 0 );
}


void ShapeSpatialPakTemplateCmd::changeField4a ( float value )
{
	char text[ _numDigits + _fpDigits + 1 ];
	char formatString[ _numDigits + _fpDigits + 1 ];

	snprintf ( formatString, sizeof ( formatString ),"%s%d%s", "%.", _fpDigits, "f" );
	formatString [ sizeof ( formatString ) - 1 ] = 0;
	snprintf ( text, sizeof ( text ), formatString, value );	// use format string
	text [ sizeof ( text ) - 1 ] = 0;
	sprintf ( text, "%f", value );
	XmTextFieldSetString ( _field4a, text );
}


void ShapeSpatialPakTemplateCmd::changeField4b ( float value )
{
	char text[ _numDigits + _fpDigits + 1];
	char formatString[ _numDigits + _fpDigits + 1 ];

	snprintf ( formatString, sizeof ( formatString ),"%s%d%s", "%.", _fpDigits, "f" );
	formatString [ sizeof ( formatString ) - 1 ] = 0;
	snprintf ( text, sizeof ( text ), formatString, value );	// use format string
	text [ sizeof ( text ) - 1 ] = 0;
	sprintf ( text, "%f", value );

	XmTextFieldSetString ( _field4b, text );
}


void ShapeSpatialPakTemplateCmd::funct5Callback ( Widget, XtPointer clientData, XtPointer )
{
	ShapeSpatialPakTemplateCmd *obj = ( ShapeSpatialPakTemplateCmd * ) clientData;

	char text1[obj->_numDigits+obj->_fpDigits];
	char text2[obj->_numDigits+obj->_fpDigits];
	float value1, value2;

	snprintf ( text1, sizeof ( text1 ), "%s", XmTextFieldGetString ( obj->_field5a ) );
	text1 [ sizeof ( text1 ) - 1 ] = 0;

	if ( strlen ( text1 ) > 0 )
		sscanf ( text1, "%f", &value1 );
	else
	{
		value1 = 1;
		obj->changeField5a ( value1 );
	}
	
	snprintf ( text2, sizeof ( text2 ), "%s", XmTextFieldGetString ( obj->_field5b ) );
	text2 [ sizeof ( text2 ) - 1 ] = 0;

	if ( strlen ( text2 ) > 0 )
		sscanf ( text2, "%f", &value2 );
	else
	{
		value2 = 1;
		obj->changeField5b ( value2 );
	}
	
	obj->funct5 ( value1, value2 );
}


void ShapeSpatialPakTemplateCmd::funct5 ( float start, float end )
{
	if ( _dataType == 0 )
	{
		if ( _gic == NULL )
			return;
	}
	else
	{
		if ( _gfc == NULL )
			return;
	}

	if ( start == 0 )
	{
		changeField5a ( 1 );
		return;
	}
	
	if ( end == 0 )
	{
		changeField5b ( 1 );
		return;
	}

	if ( ( start < 0 ) && ( end > 0 ) )
	{
		char msg[236];
		strncpy ( msg, "Error: range crosses zero: illegal value.\n\
Process this range in separate sections with\nnon-zero bounds.", sizeof ( msg ) );
		msg [ sizeof ( msg ) - 1 ] = 0;
		messageDialogManager->post ( msg );
		return;
	}
	
	long count;
	float value, scale, increment;

	if ( readData() != 0 )
		return;

	// function body
	increment = ( end - start ) / ( _endData - _startData );
	scale = _max;
	value = start;

	for ( count = _startData; count <= _endData; count ++ )
	{

		if ( _dataType == 0 )	// int
		{
			_idata [ count - _dataOffset ] = ( int ) ( log ( value ) * scale ) ;
			value += increment;
		}
		else
		{
			_fdata [ count - _dataOffset ] = ( float ) log ( value );
			value += increment;
		}
	}

	writeData();
}


void ShapeSpatialPakTemplateCmd::field5aEntryCallback ( Widget, XtPointer clientData, XtPointer )
{
	ShapeSpatialPakTemplateCmd* obj = ( ShapeSpatialPakTemplateCmd * ) clientData;
	char text[obj->_numDigits+obj->_fpDigits];

	snprintf ( text, sizeof ( text ), "%s", XmTextFieldGetString ( obj->_field5a ) );
	text [ sizeof ( text ) - 1 ] = 0;
	
	if ( strlen ( text ) == 0 )
	{
		strncpy ( text, "0", sizeof ( text ) );
		text [ sizeof ( text ) ] = 0;
	}

	obj->field5aEntry ( text );
}


void ShapeSpatialPakTemplateCmd::field5bEntryCallback ( Widget, XtPointer clientData, XtPointer )
{
	ShapeSpatialPakTemplateCmd* obj = ( ShapeSpatialPakTemplateCmd * ) clientData;
	char text[obj->_numDigits+obj->_fpDigits];

	snprintf ( text, sizeof ( text ), "%s", XmTextFieldGetString ( obj->_field5b ) );
	text [ sizeof ( text ) - 1 ] = 0;

	if ( strlen ( text ) == 0 )
	{
		strncpy ( text, "0", sizeof ( text ) );
		text [ sizeof ( text ) ] = 0;
	}

	obj->field5bEntry ( text );
}


void ShapeSpatialPakTemplateCmd::field5aEntry ( char *text )
{
	float value;
	
	if ( !checkTextEntry ( text ) )
	{
		sscanf ( text, "%f\n", &value );
	
		if ( value < 0 )
			changeField5a ( 0 );
		else
			changeField5a ( value );
	}
	else
		changeField5a ( 0 );
}


void ShapeSpatialPakTemplateCmd::field5bEntry ( char *text )
{
	float value;
	
	if ( !checkTextEntry ( text ) )
	{
		sscanf ( text, "%f\n", &value );
		
		if ( value < 0 )
			changeField5b ( 0 );
		else
			changeField5b ( value );
	}
	else
		changeField5b ( 0 );
}


void ShapeSpatialPakTemplateCmd::changeField5a ( float value )
{	
	char text[ _numDigits + _fpDigits + 1 ];
	char formatString[ _numDigits + _fpDigits + 1 ];

	snprintf ( formatString, sizeof ( formatString ),"%s%d%s", "%.", _fpDigits, "f" );
	formatString [ sizeof ( formatString ) - 1 ] = 0;
	snprintf ( text, sizeof ( text ), formatString, value );	// use format string
	text [ sizeof ( text ) - 1 ] = 0;
	sprintf ( text, "%f", value );
	XmTextFieldSetString ( _field5a, text );
}


void ShapeSpatialPakTemplateCmd::changeField5b ( float value )
{
	char text[ _numDigits + _fpDigits + 1];
	char formatString[ _numDigits + _fpDigits + 1 ];

	snprintf ( formatString, sizeof ( formatString ),"%s%d%s", "%.", _fpDigits, "f" );
	formatString [ sizeof ( formatString ) - 1 ] = 0;
	snprintf ( text, sizeof ( text ), formatString, value );	// use format string
	text [ sizeof ( text ) - 1 ] = 0;
	sprintf ( text, "%f", value );

	XmTextFieldSetString ( _field5b, text );
}


void ShapeSpatialPakTemplateCmd::funct6Callback ( Widget, XtPointer clientData, XtPointer )
{
	ShapeSpatialPakTemplateCmd *obj = ( ShapeSpatialPakTemplateCmd * ) clientData;

	char text1[obj->_numDigits+obj->_fpDigits];
	char text2[obj->_numDigits+obj->_fpDigits];
	float value1, value2;

	snprintf ( text1, sizeof ( text1 ), "%s", XmTextFieldGetString ( obj->_field6a ) );
	text1 [ sizeof ( text1 ) - 1 ] = 0;

	if ( strlen ( text1 ) > 0 )
		sscanf ( text1, "%f", &value1 );
	else
	{
		value1 = 1;
		obj->changeField6a ( value1 );
	}
	
	snprintf ( text2, sizeof ( text2 ), "%s", XmTextFieldGetString ( obj->_field6b ) );
	text2 [ sizeof ( text2 ) - 1 ] = 0;

	if ( strlen ( text2 ) > 0 )
		sscanf ( text2, "%f", &value2 );
	else
	{
		value2 = 1;
		obj->changeField6b ( value2 );
	}
	
	obj->funct6 ( value1, value2 );
}


void ShapeSpatialPakTemplateCmd::funct6 ( float shift, float scale )
{
	if ( _dataType == 0 )
	{
		if ( _gic == NULL )
			return;
	}
	else
	{
		if ( _gfc == NULL )
			return;
	}

	long count;

	if ( readData() != 0 )
		return;

	// function body
	for ( count = _startData; count <= _endData; count ++ )
	{
		if ( _dataType == 0 )	// int
			_idata [ count - _dataOffset ] = ( int ) ( ( ( float ) _idata [ count - _dataOffset ] * scale ) + shift );
		else
			_fdata [ count - _dataOffset ] = _fdata [ count - _dataOffset ] * scale + shift;
	}

	writeData();
}


void ShapeSpatialPakTemplateCmd::field6aEntryCallback ( Widget, XtPointer clientData, XtPointer )
{
	ShapeSpatialPakTemplateCmd* obj = ( ShapeSpatialPakTemplateCmd * ) clientData;
	char text[obj->_numDigits+obj->_fpDigits];

	snprintf ( text, sizeof ( text ), "%s", XmTextFieldGetString ( obj->_field6a ) );
	text [ sizeof ( text ) - 1 ] = 0;
	
	if ( strlen ( text ) == 0 )
	{
		strncpy ( text, "0", sizeof ( text ) );
		text [ sizeof ( text ) ] = 0;
	}

	obj->field6aEntry ( text );
}


void ShapeSpatialPakTemplateCmd::field6bEntryCallback ( Widget, XtPointer clientData, XtPointer )
{
	ShapeSpatialPakTemplateCmd* obj = ( ShapeSpatialPakTemplateCmd * ) clientData;
	char text[obj->_numDigits+obj->_fpDigits];

	snprintf ( text, sizeof ( text ), "%s", XmTextFieldGetString ( obj->_field6b ) );
	text [ sizeof ( text ) - 1 ] = 0;

	if ( strlen ( text ) == 0 )
	{
		strncpy ( text, "1", sizeof ( text ) );
		text [ sizeof ( text ) ] = 0;
	}

	obj->field6bEntry ( text );
}


void ShapeSpatialPakTemplateCmd::field6aEntry ( char *text )
{
	float value;
	
	if ( !checkTextEntry ( text ) )
	{
		sscanf ( text, "%f\n", &value );
		changeField6a ( value );
	}
	else
		changeField6a ( 0 );
}


void ShapeSpatialPakTemplateCmd::field6bEntry ( char *text )
{
	float value;
	
	if ( !checkTextEntry ( text ) )
	{
		sscanf ( text, "%f\n", &value );
		changeField6b ( value );
	}
	else
		changeField6b ( 1 );
}


void ShapeSpatialPakTemplateCmd::changeField6a ( float value )
{	
	char text[ _numDigits + _fpDigits + 1 ];
	char formatString[ _numDigits + _fpDigits + 1 ];

	snprintf ( formatString, sizeof ( formatString ),"%s%d%s", "%.", _fpDigits, "f" );
	formatString [ sizeof ( formatString ) - 1 ] = 0;
	snprintf ( text, sizeof ( text ), formatString, value );	// use format string
	text [ sizeof ( text ) - 1 ] = 0;
	sprintf ( text, "%f", value );
	XmTextFieldSetString ( _field6a, text );
}


void ShapeSpatialPakTemplateCmd::changeField6b ( float value )
{
	char text[ _numDigits + _fpDigits + 1];
	char formatString[ _numDigits + _fpDigits + 1 ];

	snprintf ( formatString, sizeof ( formatString ),"%s%d%s", "%.", _fpDigits, "f" );
	formatString [ sizeof ( formatString ) - 1 ] = 0;
	snprintf ( text, sizeof ( text ), formatString, value );	// use format string
	text [ sizeof ( text ) - 1 ] = 0;
	sprintf ( text, "%f", value );

	XmTextFieldSetString ( _field6b, text );
}


void ShapeSpatialPakTemplateCmd::funct7Callback ( Widget, XtPointer clientData, XtPointer )
{
	ShapeSpatialPakTemplateCmd *obj = ( ShapeSpatialPakTemplateCmd * ) clientData;

	char text1[obj->_numDigits+obj->_fpDigits];
	char text2[obj->_numDigits+obj->_fpDigits];
	unsigned int value1;
	float value2;

	snprintf ( text1, sizeof ( text1 ), "%s", XmTextFieldGetString ( obj->_field7a ) );
	text1 [ sizeof ( text1 ) - 1 ] = 0;

	if ( strlen ( text1 ) > 0 )
		sscanf ( text1, "%u", &value1 );
	else
	{
		value1 = 1;
		obj->changeField7a ( value1 );
	}

	snprintf ( text2, sizeof ( text2 ), "%s", XmTextFieldGetString ( obj->_field7b ) );
	text2 [ sizeof ( text2 ) - 1 ] = 0;

	if ( strlen ( text2 ) > 0 )
		sscanf ( text2, "%f", &value2 );
	else
	{
		value2 = 2;
		obj->changeField7b ( value2 );
	}

	obj->funct7 ( value1, value2 );
}


void ShapeSpatialPakTemplateCmd::funct7 ( unsigned int numPoints, float weighting )
{
	if ( _dataType == 0 )
	{
		if ( _gic == NULL )	// we don't deal with int arrays for spatial
							// templates, they're all f.p.
			return;
	}
	else
	{
		if ( _gfc == NULL )
			return;

		if ( readData() != 0  )
			return;

		// separate BreakCmd instance for this lengthy op
		DataConformCmd *dataConform = new DataConformCmd ( "dataConform", TRUE,
													_fdata, NULL, _startData, _endData,
													numPoints, weighting, _dataType, _fileName );
		
		dataConform->execute ( &ShapeSpatialPakTemplateCmd::dataConformFinishedCallback, ( void * ) this );
	}
}


void ShapeSpatialPakTemplateCmd::dataConformFinishedCallback ( BreakCmd *cmd, Boolean interrupted, void *clientData )
{
	DataConformCmd *dcObj = ( DataConformCmd * ) cmd;
	ShapeSpatialPakTemplateCmd *obj = ( ShapeSpatialPakTemplateCmd * ) clientData;

	if ( interrupted )
		infoDialogManager->post ( "Interrupted!" );
	else                               
		obj->dataConformFinished ( dcObj );

//	obj->setNormalCursor();
	delete dcObj;
}


void ShapeSpatialPakTemplateCmd::dataConformFinished ( DataConformCmd *dcObj )
{
	if ( dcObj->error() != 0 )
	{
		char msg [ strlen ( _fileName ) + 256 ];
		snprintf ( msg, sizeof ( msg ), "%s\nDataConformCmd error: ", _fileName );
		msg [ sizeof ( msg ) - 1 ]  = 0;
		
		if ( dcObj->error() == 1 )
			strncat ( msg, "name too long for allocated space.", sizeof ( msg ) );

		if ( dcObj->error() == 2 )
			strncat ( msg, "less than requested items written to file.", sizeof ( msg ) );

		if ( dcObj->error() == 3 )
			strncat ( msg, "less than requested items read from file.", sizeof ( msg ) );

		msg [ sizeof ( msg ) - 1 ] = 0;
		messageDialogManager->post ( msg );
	}
	else
		writeData();
}


void ShapeSpatialPakTemplateCmd::field7aEntryCallback ( Widget, XtPointer clientData, XtPointer )
{
	ShapeSpatialPakTemplateCmd* obj = ( ShapeSpatialPakTemplateCmd * ) clientData;
	char text[obj->_numDigits+obj->_fpDigits];

	snprintf ( text, sizeof ( text ), "%s", XmTextFieldGetString ( obj->_field7a ) );
	text [ sizeof ( text ) - 1 ] = 0;
	
	if ( strlen ( text ) == 0 )
	{
		strncpy ( text, "1", sizeof ( text ) );
		text [ sizeof ( text ) ] = 0;
	}

	obj->field7aEntry ( text );
}


void ShapeSpatialPakTemplateCmd::field7aEntry ( char *text )
{
	unsigned int value;
	
	if ( !checkTextEntry ( text ) )
	{
		sscanf ( text, "%u", &value );
		changeField7a ( value );
	}
	else
		changeField7a ( 1 );
}


void ShapeSpatialPakTemplateCmd::changeField7a ( unsigned int value )
{	
	if ( value > ( unsigned int ) ( _endData - _startData - 1 ) )
		value = ( unsigned int ) _endData - _startData - 1;
			
	char text[ _numDigits + 1 ];
	snprintf ( text, sizeof ( text ), "%u", value );
	text [ sizeof ( text ) - 1 ] = 0;
	XmTextFieldSetString ( _field7a, text );
}


void ShapeSpatialPakTemplateCmd::field7bEntryCallback ( Widget, XtPointer clientData, XtPointer )
{
	ShapeSpatialPakTemplateCmd* obj = ( ShapeSpatialPakTemplateCmd * ) clientData;
	char text[obj->_numDigits+obj->_fpDigits];

	snprintf ( text, sizeof ( text ), "%s", XmTextFieldGetString ( obj->_field7b ) );
	text [ sizeof ( text ) - 1 ] = 0;

	if ( strlen ( text ) == 0 )
	{
		strncpy ( text, "2", sizeof ( text ) );
		text [ sizeof ( text ) ] = 0;
	}

	obj->field7bEntry ( text );
}


void ShapeSpatialPakTemplateCmd::field7bEntry ( char *text )
{
	float value;

	if ( !checkTextEntry ( text ) )
	{
		sscanf ( text, "%f", &value );

		if ( value < 0 )
			value *= -1;	// don't invert the view, might confuse the user

		changeField7b ( value );
	}
	else
		changeField7b ( 2 );
}


void ShapeSpatialPakTemplateCmd::changeField7b ( float value )
{
	char text[ _numDigits + 1 ];
	snprintf ( text, sizeof ( text ), "%f", value );
	text [ sizeof ( text ) - 1 ] = 0;
	XmTextFieldSetString ( _field7b, text );
}


int ShapeSpatialPakTemplateCmd::checkTextEntry ( char *text )
{
	int error = 0;
	int length = strlen ( text );
	char c = 0;

	for ( int count = 0; count < length; count++ )
	{
		c = text [ count ];

		if ( ( c < '0' ) || ( c > '9' ) )
		{
			if (  c == '.' )
				error = 0;
			else
			{
				if ( ( c == '-' ) && ( count == 0 ) )
					error = 0;
				else
				{
					char msg[26];
					sprintf ( msg, "Error: '%c' non-numeric.", c );
					messageDialogManager->post( msg );
					error = 1;
				}
			}
		}
	}

	if ( error )
	{
		// assume invalid, pop up format msg
		char msg[BUFSIZE];
		snprintf ( msg, sizeof ( msg ), "Invalid format %s",  text );
		msg [ sizeof ( msg ) - 1 ] = 0;
		messageDialogManager->post ( msg );
	}
	
	return error;
}


int ShapeSpatialPakTemplateCmd::readData()
{
	switch ( _dataType )
	{
		case 0:	// int
			if ( _gic == NULL )
				return ( 1 );

			break;
			
		case 1:	// float
			if ( _gfc == NULL )
				return ( 1 );
		
			break;
		
		default:	return ( 1 );
	}

	if ( ( _startSel < _startRange ) || ( _endSel > _endRange ) )
		return ( 1 );

	_startData = _startSel;
	_endData = _endSel;

	return ( 0 );
}


void ShapeSpatialPakTemplateCmd::writeData()
{
	_dataChanged = 1;
	
	if ( _dataType == 0 )
		_gic->redisplay ( _startRange, _endRange, _startSel,
					_endSel, _xCurrent, _dataOffset );
	else
		_gfc->redisplay ( _startRange, _endRange, _startSel,
					_endSel, _startSel, _dataOffset );
}


void ShapeSpatialPakTemplateCmd::templateID ( char *templateDataFile, long startRange,
						long endRange, long startSel,
						long endSel, long xCurrent,
						float min, float max,
						GraphIntCmd *gic, GraphFltCmd *gfc,
						int *intArray, float *fltArray,
						int dataType, unsigned int callerID )
{
	if ( startSel == endSel )
		return;	// nothing to do

	if ( callerID == 0 )
		return;

	strncpy ( _fileName, templateDataFile, sizeof ( _fileName ) );
	_fileName [ sizeof ( _fileName ) - 1 ] = 0;

	_startRange = startRange;
	_endRange = endRange;
	_startSel = startSel;
	_endSel = endSel;
	_xCurrent = xCurrent;
	_min = min;
	_max = max;
	_idata = intArray;
	_fdata = fltArray;
	_gic = gic;
	_gfc = gfc;
	_dataType = dataType;
	_viewID = callerID;

	char title [ strlen ( _fileName ) + 1 ];
	
	strncpy ( title, _utils->fileFromPath ( _fileName ), sizeof ( title ) );
	title [ sizeof ( title ) - 1 ] = 0;

	setTitle ( title );
}	


void ShapeSpatialPakTemplateCmd::updateSelection ( unsigned int callerID,
							long startRange,
							long endRange,
							long startSel,
							long endSel,
							long dataOffset,
							int *intArray,
							float *fltArray )
{
	if ( startSel == endSel )
		return;	// nothing to do

	if ( callerID == 0 )
		return;

	if ( callerID == _viewID )
	{
		_startRange = startRange;
		_endRange = endRange;
		_startSel = startSel;
		_endSel = endSel;
		_dataOffset = dataOffset;
		_idata = intArray;
		_fdata = fltArray;
		readData();
		changeField1a ( _fdata [ _startData - _dataOffset ] );
		changeField1b ( _fdata [ _endData - _dataOffset ] );
	}
}

