/*
 ToggleInterface.cc

 Douglas A. Young, 'Object-oriented Programming with C++ and OSF/Motif'
 2nd ed., Prentice-Hall.
*/

#include "ToggleInterface.h"
#include <Xm/ToggleB.h>


ToggleInterface::ToggleInterface ( Widget parent, Cmd *cmd ) : CmdInterface ( cmd )
{
	_w = XtCreateWidget ( _name, xmToggleButtonWidgetClass, parent, NULL, 0 );
	installDestroyHandler();
	
	if ( _active )
		activate();
	else
		deactivate();
		
	XtAddCallback ( _w, XmNvalueChangedCallback, &CmdInterface::executeCmdCallback,
					( XtPointer ) this );
}
